;/*********************************************************************************************************
;						EXExceptionMessages.mc
;
; PURPOSE:	CONTAINS MESSAGE DEFINITIONS FOR THE EXCEPTION HANDLING SUBSYSTEM
;
; AUTHOR:	ERIC GUFFORD - 10/97
;
;COPYRIGHT 1997 - 1998, TRIAD Systems Inc. 
;This source code may be used and modified without resitriction as long as the copyright and author data remains intact.
;***********************************************************************************************************************
;USE OF THIS SOURCE CODE IS AT THE USER'S SOLE DISCRETION.  TRIAD Systems Inc. MAKES NO WARRANTY, EXPRESSED OR IMPLIED,
;REGARDING THE APPROPRIATNESS OR MERCHANTABILITY OF THIS SOURCE CODE.  TRIAD Systems Inc. WILL NOT BE RESPONSIBLE FOR ANY
;DAMAGES, MONETARY OR OTHERWISE, ARISING FROM THE USE OF THIS SOURCE CODE.  USE OF THIS SOURCE CODE, IN ANY WAY, IN WHOLE
;OR IN FRAGMENT, CONSTITUES ACCEPTANCE OF THESE TERMS AND CONDITIONS.
;**********************************************************************************************************
;NOTES:
;
;*********************************************************************************************************/
;
MessageIdTypedef=DWORD

SeverityNames=(Trace=0x0:SEVERITY_TRACE
               Warning=0x1:SEVERITY_WARNING
               Error=0x2:SEVERITY_ERROR
               Fatal=0x3:SEVERITY_FATAL
              )

FacilityNames=(Exceptions=257:FACILITY_EXCEPTIONS)
LanguageNames=(English=0x409:ExceptionMessages)
;//LanguageNames=(English=0x409:ExceptionMessages)

;#pragma warning(disable:4005) //TURN OFF THE 'MACRO REDEFINITION' WARNING

;//-------------------------------------------------------------------------
;// MESSAGE DEFINITION SECTION
;
;// Each message definition begins with one or more of the following
;// statements:
;
;// MessageId = [number|+number]
;// Severity = severity_name
;// Facility = facility_name
;// SymbolicName = name

MessageId=0x01
Severity=Fatal
Facility=Exceptions
SymbolicName=PROGRAM_ABORTED
Language=English
%1 %n This program will now be terminated
.

MessageId=0x2
Severity=Fatal
Facility=Exceptions
SymbolicName=UNEXPECTED_EXCEPTION
Language=English
%1 %n An unexpected exception has been detected
.

MessageId=0x3
Severity=Error
Facility=Exceptions
SymbolicName=SANITY_FAILURE
Language=English
%1 %n Object integrity has been compromised 
.

MessageId=0x4
Severity=Error
Facility=Exceptions
SymbolicName=ACCESS_VIOLATION_WRITE
Language=English
%1 %n The thread tried to write to a virtual address for which it does not have the appropriate access
.

MessageId=0x5
Severity=Error
Facility=Exceptions
SymbolicName=ACCESS_VIOLATION_READ
Language=English
%1 %n The thread tried to read fromo a virtual address for which it does not have the appropriate access
.

MessageId=0x6
Severity=Error
Facility=Exceptions
SymbolicName=DATATYPE_MISALIGNMENT
Language=English
%1 %n The thread tried to read or write data that is misaligned on hardware that does not provide alignment
.

MessageId=0x7
Severity=Error
Facility=Exceptions
SymbolicName=ARRAY_BOUNDS_EXCEEDED
Language=English
%1 %n The thread tried to access an array element that is out of bounds
.

MessageId=0x8
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_DENORMAL_OPERAND
Language=English
%1 %n One of the operands in a floating-point operation is denormal
.

MessageId=0x9
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_DIVIDE_BY_ZERO
Language=English
%1 %n A floating point divide by zero exception occurred
.

MessageId=0xA
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_INVALID_OPERATION
Language=English
%1 %n An invalid floating point operation was performed
.

MessageId=0xB
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_OVERFLOW
Language=English
%1 %n A floating point overflow was detected
.

MessageId=0xC
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_UNDERFLOW
Language=English
%1 %n A floating point underflow was detected
.

MessageId=0xD
Severity=Error
Facility=Exceptions
SymbolicName=FLOAT_STACK_CHECK
Language=English
%1 %n The stack overflowed or underflowed as the result of a floating-point operation
.

MessageId=0xE
Severity=Error
Facility=Exceptions
SymbolicName=INT_DIVIDE_BY_ZERO
Language=English
%1 %n A interger based divide by zero exception occurred
.

MessageId=0xF
Severity=Error
Facility=Exceptions
SymbolicName=INT_OVERFLOW
Language=English
%1 %n An integer overflow was detected
.

MessageId=0x10
Severity=Error
Facility=Exceptions
SymbolicName=PRIV_INSTRUCTION
Language=English
%1 %n A priviledged instruction was attempted
.

MessageId=0x11
Severity=Error
Facility=Exceptions
SymbolicName=PRIV_INSTRUCTION
Language=English
%1 %n A priviledged instruction was attempted
.

MessageId=0x12
Severity=Error
Facility=Exceptions
SymbolicName=IN_PAGE_ERROR
Language=English
%1 %n A inbound paging operation failed
.

MessageId=0x13
Severity=Error
Facility=Exceptions
SymbolicName=ILLEGAL_INSTRUCTION
Language=English
%1 %n An illegal instruction was attempted
.

MessageId=0x14
Severity=Error
Facility=Exceptions
SymbolicName=NONCONTINUABLE_EXCEPTION
Language=English
%1 %n The thread tried to continue execution after a noncontinuable exception occurred
.

MessageId=0x15
Severity=Error
Facility=Exceptions
SymbolicName=STACK_OVERFLOW
Language=English
%1 %n A Stack overflow was detected
.

MessageId=0x16
Severity=Error
Facility=Exceptions
SymbolicName=INVALID_DISPOSITION
Language=English
%1 %n An exception handler returned an invalid disposition to the exception dispatcher
.

MessageId=0x17
Severity=Error
Facility=Exceptions
SymbolicName=GUARD_PAGE
Language=English
%1 %n The thread attempted to access a guard page
.

MessageId=0x18
Severity=Error
Facility=Exceptions
SymbolicName=INVALID_HANDLE
Language=English
%1 %n An invalid handle was dereferenced
.

MessageId=0x19
Severity=Error
Facility=Exceptions
SymbolicName=UNKNOWN_EXCEPTION
Language=English
%1 %n An unknown exception has occurred
.

