// Application object
class CServerApp : public CWinApp
{
public:
	 virtual BOOL InitInstance();
	 virtual int  ExitInstance();
};

// Main window, also inherited from DDEServer
class CMainWindow : public CFrameWnd, public DDEServer
{
	 UINT PointClipFormat;// Clipboard format for Position
	 CPoint Position;     // Position of rectangle in client area
	 int CountClients;    // Number of clients connected
public: 
	 CMainWindow();

    // Overridden DDEServer's virtual functions
	virtual BOOL AcceptConversation(const DDEString & Topic);
    virtual BOOL AcceptAdvise(const DDEString & Topic, const DDEString & Item, UINT format, HCONV hConv);
    virtual BOOL PrepareAdviseData(const DDEString & Topic, const DDEString & Item, DDEDataOut & Data, UINT CountRemaining, HCONV hConv);
    virtual BOOL HandlePoke(const DDEString & Topic, const DDEString & Item, const DDEDataIn & Data, HCONV hConv);
    virtual BOOL HandleRequest(const DDEString & Topic, const DDEString & Item, DDEDataOut & Data, HCONV hConv);
    virtual BOOL HandleExecute(const DDEString & Topic, LPSTR commands, HCONV hConv);
    virtual void BeginConversation(const DDEString & Topic,HCONV hConversation);
    virtual void EndConversation(const DDEString & Topic,HCONV hConversation);
	virtual void SystemAddTopics(CString & Topics);

protected:

	 // Windows message handlers
	 afx_msg void OnPaint();
     afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	 afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	 afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	 DECLARE_MESSAGE_MAP()
};
